﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SqlSugar;
using XF.Domain.Repository;

namespace Hotline.FlowEngine.Workflows
{
    public class WorkflowCountersign : CreationEntity
    {
        public string WorkflowId { get; set; }

        /// <summary>
        /// 发起会签节点code
        /// </summary>
        public string StartStepCode { get; set; }

        /// <summary>
        /// 会签汇总节点code
        /// </summary>
        public string EndStepCode { get; set; }

        /// <summary>
        /// 会签结束时间
        /// </summary>
        public DateTime? CompleteTime { get; set; }

        /// <summary>
        /// 会签嵌套会签场景记录上级会签Id
        /// </summary>
        [SugarColumn(IsNullable = true)]
        public string? ParentId { get; set; }

        /// <summary>
        /// 该会签参与成员数量
        /// </summary>
        public int Members { get; set; }

        /// <summary>
        /// 会签是否完成(如有嵌套会签，下级所有会签都完成才可判定当前会签为完成)
        /// </summary>
        public bool IsCompleted() => CompleteTime.HasValue;
    }

}
